/* 
 *  gstalker stock charter
 * 
 *  Copyright (c) 1998 Stefan S. Stratigakos
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
 *  USA.
 */


#include "myheader.h"
#include <stdio.h>
#include <stdlib.h>

/*****************************************************************************************/
void draw_date()
{
	GdkColor *color;
       	GdkGC *gc;
	char tempstring[250], tempstring2[250], tempstring3[250], *monthstring;
	long arraypointer;
	int x, tempinteger2, red, blue, green;
	GdkFont *font;
	extern int current_width, current_height, pixelspace, entries, grid_flag;
	extern GtkWidget *chart;
	extern GdkPixmap *pixmap;
	extern long *date_array;
	
        
        current_width = chart->allocation.width;
	current_height = chart->allocation.height - DATECANVAS_SIZE;
        font = gdk_font_load ("-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*");
        gdk_draw_line (pixmap, chart->style->white_gc, 0, current_height,
        	       current_width, current_height);
	sprintf(tempstring, "%ld", *date_array);
	tempstring3[0] = tempstring[5];
	for (arraypointer = 0; arraypointer < entries; arraypointer++)
	{
	     sprintf(tempstring, "%ld", *(date_array + arraypointer));
	     if (tempstring[5] != tempstring3[0])
	     {
		tempstring3[0] = tempstring[5];
		x = arraypointer * pixelspace;
	       	gdk_draw_line (pixmap, chart->style->white_gc, x, 
	       		       current_height, x,
	       		       current_height + 5);
	       	if (grid_flag)
	       	{
	       		red = 0;
	       		blue = 100;
	       		green = 0;
	       		gc = gdk_gc_new(chart->window);
       			color = (GdkColor *)malloc(sizeof(GdkColor));
       			color->red = red * (65535/255);
       			color->green = green * (65535/255);
       			color->blue = blue * (65535/255);
       			gdk_color_alloc(gtk_widget_get_colormap(chart), color);
       			gdk_gc_set_foreground(gc, color);
       			gdk_draw_line (pixmap, gc, x, current_height - 2, x, 0);
	       	}
	       	sprintf(tempstring, "%ld", *(date_array + arraypointer));
	       	tempstring2[0] = tempstring[4];
	       	tempstring2[1] = tempstring[5];
	       	tempstring2[2] = 0;
	       	tempinteger2 = (int)atoi(tempstring2);
	       	switch(tempinteger2)
        	{
                	case 1 :
                		strcpy(tempstring2, tempstring);
               			tempstring2[4] = 0;
               			gdk_draw_string	 (pixmap, font, chart->style->white_gc,
               					  x -13, current_height + 16, tempstring2);
               			break;
               		case 2 :
               			if (pixelspace > 2)
               			{
               				monthstring = "Feb";
               				x = x - 9;
               			}
               			else
               			{
               				monthstring = "F";
               				x = x - 4;
               			}
               			gdk_draw_string	 (pixmap, font, chart->style->white_gc,
               					  x , current_height + 16, monthstring);
                		break;
                	case 3 :
                		if (pixelspace > 2)
                		{
                			monthstring = "Mar";
                			x = x - 13;
                		}
                		else
                		{
                			monthstring = "M";
                			x = x - 5;
                		}
                		gdk_draw_string	 (pixmap, font, chart->style->white_gc,
               					  x , current_height + 16, monthstring);
                		break;
                	case 4 :
                		if (pixelspace > 2)
                		{
                			monthstring = "Apr";
                			x = x - 9;
                		}
                		else
                		{
                			monthstring = "A";
                			x = x - 4;
                		}
                		gdk_draw_string	 (pixmap, font, chart->style->white_gc,
               					  x , current_height + 16, monthstring);
                		break;
                	case 5 :
                		if (pixelspace > 2)
                		{
                			monthstring = "May";
                			x = x - 13;
                		}
                		else
                		{
                			monthstring = "M";
                			x = x - 5;
                		}
                		gdk_draw_string	 (pixmap, font, chart->style->white_gc,
               					  x , current_height + 16, monthstring);
                		break;
                	case 6 :
                		if (pixelspace > 2)
                		{
                			monthstring = "Jun";
                			x = x - 9;
                		}
                		else
                		{
                			monthstring = "J";
                			x = x - 5;
                		}
                		gdk_draw_string	 (pixmap, font, chart->style->white_gc,
               					  x , current_height + 16, monthstring);
                		break;
                	case 7 :
                		if (pixelspace > 2)
                		{
                			monthstring = "Jul";
                			x = x - 10;
                		}
                		else
                		{
                			monthstring = "J";
                			x = x - 5;
                		}
                		gdk_draw_string	 (pixmap, font, chart->style->white_gc,
               					  x , current_height + 16, monthstring);
                		break;
                	case 8 :
                		if (pixelspace > 2)
                		{
                			monthstring = "Aug";
                			x = x - 10;
                		}
                		else
                		{
                			monthstring = "A";
                			x = x - 4;
                		}
                		gdk_draw_string	 (pixmap, font, chart->style->white_gc,
               					  x , current_height + 16, monthstring);
                		break;
                	case 9 :
                		if (pixelspace > 2)
                		{
                			monthstring = "Sep";
                			x = x - 11;
                		}
                		else
                		{
                			monthstring = "S";
                			x = x - 5;
                		}
                		gdk_draw_string	 (pixmap, font, chart->style->white_gc,
               					  x , current_height + 16, monthstring);
                		break;
                	case 10 :
                		if (pixelspace > 2)
                		{
                			monthstring = "Oct";
                			x = x - 11;
                		}
                		else
                		{
                			monthstring = "O";
                			x = x - 5;
                		}
                		gdk_draw_string	 (pixmap, font, chart->style->white_gc,
               					  x , current_height + 16, monthstring);
                		break;
                	case 11 :
                		if (pixelspace > 2)
                		{
                			monthstring = "Nov";
                			x = x - 10;
                		}
                		else
                		{
                			monthstring = "N";
                			x = x - 5;
                		}
                		gdk_draw_string	 (pixmap, font, chart->style->white_gc,
               					  x , current_height + 16, monthstring);
                		break;
                	case 12 :
                		if (pixelspace > 2)
                		{
                			monthstring = "Dec";
                			x = x - 10;
                		}
                		else
                		{
                			monthstring = "D";
                			x = x - 5;
                		}
                		gdk_draw_string	 (pixmap, font, chart->style->white_gc,
               					  x , current_height + 16, monthstring);
                		break;
                	default :
				break;
		}
	    }
	}
}
/*********************************************************************************/
void draw_volume()
{
	GdkFont *font;
	char tstring[25];
	int tempinteger, tempinteger2;
	long arraypointer, tlong;
	float tempfloat, tempfloat2;
	extern GdkPixmap *pixmap, *pixmap2;
	extern GtkWidget *chart;
	extern int current_height, current_width, pixelspace, entries;
	extern long *volume_array, volume_high;
	
	
	current_width = chart->allocation.width;	
	current_height = chart->allocation.height - DATECANVAS_SIZE;
	gdk_draw_line (pixmap, chart->style->white_gc, 0, current_height - VOLUME_WINDOW_SIZE,
        	       current_width, current_height - VOLUME_WINDOW_SIZE);
        	       
        font = gdk_font_load ("-*-helvetica-medium-r-normal-*-10-*-*-*-*-*-*-*");
        current_height = chart->allocation.height - DATECANVAS_SIZE + 4;
        gdk_draw_line (pixmap2, chart->style->white_gc,
		       0, current_height - 12, 2, current_height - 12);
        gdk_draw_line (pixmap2, chart->style->white_gc,
		       0, current_height - 25, 2, current_height - 25);
	tlong = volume_high / 2;
	sprintf(tstring, "%ld", tlong);
	gdk_draw_string(pixmap2, font, chart->style->white_gc,
               		  6, current_height - 25 + 4, tstring);
        gdk_draw_line (pixmap2, chart->style->white_gc,
		       0, current_height - 38, 2, current_height - 38);
               		  
        current_height = chart->allocation.height - DATECANVAS_SIZE;
	tempinteger = 0;
	arraypointer = 0;
	while (arraypointer < entries)
	{
		tempfloat = *(volume_array + arraypointer);
		tempfloat2 = ((tempfloat / volume_high) * 100) / 2;
		tempinteger2 = (int)tempfloat2;
		if (tempinteger2 > 0)
		{
			gdk_draw_line (pixmap, chart->style->white_gc,
				       tempinteger, current_height,
				       tempinteger, current_height - tempinteger2);
		 }
	 	 arraypointer++;
	 	 tempinteger = tempinteger + pixelspace;
	 }
}
/**********************************************************************************/
void draw_scale()
{
	GdkColor *color;
       	GdkGC *gc;
	float tempfloat, tempfloat2, interval, y = 0;
	char tempstring[250];
	int tempinteger, tempinteger2 = 0;
	GdkFont *font;
	extern GdkPixmap *pixmap2, *pixmap;
	extern GtkWidget *scale, *chart;
	extern int volume_button_flag, current_height, current_width, grid_flag, volume;
	extern float range, maxhigh, maxlow;
	extern int red, green, blue;
	
	
	current_width = chart->allocation.width;
	current_height = chart->allocation.height - DATECANVAS_SIZE;
	if (volume_button_flag)
		current_height = chart->allocation.height-DATECANVAS_SIZE-VOLUME_WINDOW_SIZE;
	if (volume)
		current_height = chart->allocation.height-DATECANVAS_SIZE-VOLUME_WINDOW_SIZE;
	font = gdk_font_load ("-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*");
	if (range < 1)
	{
	  interval = 0.1;
	  if (range / interval < 10)
	  {
	    for (interval = 0.0025; (range / interval) >= 10; interval = interval + 0.0025)
	    {
	    }
	  }
	}
	else
	{
	  if (range < 10)
	  {
	    interval = 1;
	    if (range / interval < 10)
	    {
	      for (interval = 0.1; (range / interval) >= 10; interval = interval + 0.1)
	      {
	      }
	    }
	  }
	  else
	  {
	    if (range < 50)
	    {
	      interval = 5;	      
	      if (range / interval < 10)
	      {
	        for (interval = 1; (range / interval) >= 10; interval = interval + 1)
	        {
	        }
	      }
	    }
	    else
	    {
	      if (range < 100)
	      {
	        interval = 10;
	        if (range / interval < 10)
	        {
	          for (interval = 5; (range / interval) >= 10; interval = interval + 1)
	          {
	          }
	        }
	      }
	      else
	      {
	        if (range < 500)
	        {
	          interval = 50;
	          if (range / interval < 10)
	          {
	            for (interval = 25; (range / interval) >= 10; interval = interval + 5)
	            {
	            }
	          }
	        }
	        else
	        {
	          if (range < 1000)
	          {
	            interval = 100;
	            if (range / interval < 10)
	            {
	            	for (interval = 50; (range / interval) >= 10; interval = interval + 10)
	            	{
	            	}
	            }
	          }
	          else
	          {
	            if (range < 5000)
	            {
	              interval = 500;
	              if (range / interval < 10)
	              {
	            	for (interval = 250; (range / interval) >= 10; interval = interval + 25)
	            	{
	            	}
	              }
	            }
	            else
	            {
	              interval = 1000;
	            }
	          }
	        }
	      }
	    }
	  }
	}
	tempinteger2 = (int)(maxlow / interval);
	for (tempinteger = 1; tempinteger < 10; tempinteger++)
	{
	       if (maxlow > 10)
	       {
		     sprintf(tempstring,"%5.2f",(tempinteger2*interval)+(interval*tempinteger));
		     tempfloat = (tempinteger2 * interval) + (interval * tempinteger);
	       }	
	       else
	       {
		     sprintf(tempstring,"%5.4f",(tempinteger2*interval)+(interval*tempinteger));
		     tempfloat = (tempinteger2 * interval) + (interval * tempinteger);
	       }
	       tempfloat2 = (maxhigh - tempfloat) * (current_height / range);
	       y = (int)tempfloat2 + 2;
	       gdk_draw_string(pixmap2, font, scale->style->white_gc, 6, y + 5, tempstring);
	       gdk_draw_line (pixmap2, scale->style->white_gc, 0, y, 4, y);	       
	       if (grid_flag)
	       {
	       		red = 0;
	       		blue = 100;
	       		green = 0;
	       		gc = gdk_gc_new(chart->window);
       			color = (GdkColor *)malloc(sizeof(GdkColor));
       			color->red = red * (65535/255);
       			color->green = green * (65535/255);
       			color->blue = blue * (65535/255);
       			gdk_color_alloc(gtk_widget_get_colormap(chart), color);
       			gdk_gc_set_foreground(gc, color);
       			gdk_draw_line (pixmap, gc, 0, y - 2, current_width, y - 2);
	       }
	}
}
/***********************************************************************************/
void draw_price()
{
	int tempinteger, firstx, firsty, secondy;
	gint arraypointer;
	GdkColor *color;
       	GdkGC *gc;
	extern float maxhigh, range;
	extern int current_height, styleflag, current_width, pixelspace, volume_button_flag;
	extern GdkPixmap *pixmap;
	extern GtkWidget *chart;
	extern float *high_array, *low_array, *close_array, *open_array;
	extern int volume, red, green, blue, entries;
	
	
	gc = gdk_gc_new(chart->window);
       	color = (GdkColor *)malloc(sizeof(GdkColor));
       	color->red = red * (65535/255);
       	color->green = green * (65535/255);
       	color->blue = blue * (65535/255);
       	gdk_color_alloc(gtk_widget_get_colormap(chart), color);
       	gdk_gc_set_foreground(gc, color);
       	

       	current_width = chart->allocation.width;
       	current_height = chart->allocation.height - DATECANVAS_SIZE;
	if (volume_button_flag)
		current_height = chart->allocation.height - DATECANVAS_SIZE - VOLUME_WINDOW_SIZE;
	if (volume)
		current_height = chart->allocation.height - DATECANVAS_SIZE - VOLUME_WINDOW_SIZE;
	tempinteger = 0;
	arraypointer = 0;
	switch(styleflag)
	{
	       case 0: firstx = 0;
		firsty = (maxhigh - close_array[arraypointer]) * (current_height / range);
	        while (arraypointer < entries)
		{
			secondy = (maxhigh-close_array[arraypointer]) * (current_height / range);
			gdk_draw_line (pixmap, gc, firstx, firsty, tempinteger, secondy);
			firstx = tempinteger;
			firsty = secondy;
	       		arraypointer++;
	       		tempinteger = tempinteger + pixelspace;
	       	}
	       		break;
	       	case 1: while (arraypointer < entries)
		{
			firsty = (maxhigh - open_array[arraypointer]) * (current_height / range);
		        secondy = firsty;
		        gdk_draw_line (pixmap,gc,tempinteger,firsty,(tempinteger - 2),secondy);
		        firsty = (maxhigh - high_array[arraypointer]) * (current_height / range);
		        secondy = (maxhigh - low_array[arraypointer]) * (current_height / range);
		        gdk_draw_line (pixmap, gc, tempinteger, firsty, tempinteger, secondy);
			firsty = (maxhigh - close_array[arraypointer]) * (current_height / range);
			secondy = firsty;
			gdk_draw_line (pixmap,gc,tempinteger,firsty,(tempinteger + 2), secondy);
	       		arraypointer++;
	       		tempinteger = tempinteger + pixelspace;
	       	}
	       		break;
	       	default:
	       		break;
	}
}
/************************************************************************************/
void draw_moving_average()
{
	int tempinteger, tempinteger2, firstx, firsty, secondy;
	long arraypointer;
	float tempfloat;
	GdkColor *color;
       	GdkGC *gc;
	extern float maxhigh, range, *close_array;
	extern GdkPixmap *pixmap;
	extern GtkWidget *chart;
	extern int red, green, blue, entries, moving, current_height, pixelspace;
	
	
	gc = gdk_gc_new(chart->window);
       	color = (GdkColor *)malloc(sizeof(GdkColor));
       	color->red = red * (65535/255);
       	color->green = green * (65535/255);
       	color->blue = blue * (65535/255);
       	gdk_color_alloc(gtk_widget_get_colormap(chart), color);
       	gdk_gc_set_foreground(gc, color);
       	
	arraypointer = moving;
	firstx = moving * pixelspace;
	tempinteger = firstx;
	tempfloat = 0;
	for(tempinteger2= 0; tempinteger2 < moving; tempinteger2++)
		tempfloat = tempfloat + close_array[arraypointer - tempinteger2];
	tempfloat = tempfloat / moving;
	firsty = (maxhigh - tempfloat) * (current_height / range);
	arraypointer++;
	tempinteger = tempinteger + pixelspace;
	while (arraypointer < entries)
	{
		tempfloat = 0;
		for(tempinteger2= 0; tempinteger2 < moving; tempinteger2++)
			tempfloat = tempfloat + close_array[arraypointer - tempinteger2];
		tempfloat = tempfloat / moving;
		secondy = (maxhigh - tempfloat) * (current_height / range);
		gdk_draw_line (pixmap, gc, firstx, firsty, tempinteger, secondy);
	       	arraypointer++;
	       	firstx = tempinteger;
	       	tempinteger = tempinteger + pixelspace;
		firsty = secondy;
	 }
}
/************************************************************************************/
void draw()
{
	extern GtkWidget *chart;
	extern GdkPixmap *pixmap;
	GdkRectangle area;
	extern GtkWidget *scale;
	extern GdkPixmap *pixmap2;
	extern int volume, chartflag, moving, red, green, blue, volume_button_flag;
	
	
    	if (chartflag == 0)
    		return;
	gdk_draw_rectangle (pixmap,
			    chart->style->black_gc,
			    TRUE,
			    0, 0,
			    chart->allocation.width,
			    chart->allocation.height);
	gdk_draw_rectangle (pixmap2,
			    scale->style->black_gc,
			    TRUE,
			    0, 0,
			    scale->allocation.width,
			    scale->allocation.height);
	draw_date();
	if (volume_button_flag)
	{
		draw_volume();
	}
	if (volume)
		draw_volume();
	draw_scale();
	red = 0;
	green = 255;
	blue = 0;
	draw_price();
	if (moving)
	{
		red = 255;
		green = 0;
		blue = 0;
		draw_moving_average();
	}
	area.x = 0;
	area.y = 0;
	area.width = chart->allocation.width;
	area.height = chart->allocation.height;
	gtk_widget_draw (chart, &area);
	area.width = scale->allocation.width;
	area.height = scale->allocation.height;
	gtk_widget_draw (scale, &area);
}